JAVA解法
class Solution {
public List<String> letterCombinations(String digits) {
// 定义保存结果集的集合
List<String> combinations = new ArrayList<String>();
// 对传入的字符串进行长度校验
if (digits.length() == 0) {
return combinations;
}
// 定义一个数字与字母的映射表
Map<Character, String> phoneMap = new HashMap<Character, String>() {{
put('2', "abc");
put('3', "def");
put('4', "ghi");
put('5', "jkl");
put('6', "mno");
put('7', "pqrs");
put('8', "tuv");
put('9', "wxyz");
}};
// 调用回溯算法
backtrack(combinations, phoneMap, digits, 0, new StringBuffer());
// 返回最终结果
return combinations;
}
// 回溯算法的实现
public void backtrack(List<String> combinations, Map<Character, String> phoneMap, String digits, int index, StringBuffer combination) {
// 判断当前的位置是否达到输入数字字符串的长度
if (index == digits.length()) {
// 达到对应长度后将其加入结果集
combinations.add(combination.toString());
} else {
// 获取传入数字串的首个数字
char digit = digits.charAt(index);
// 获取数字对应的字母串
String letters = phoneMap.get(digit);
// 获取字母串的长度
int lettersCount = letters.length();
// 遍历字母串
for (int i = 0; i < lettersCount; i++) {
// 临时拼接串
combination.append(letters.charAt(i));
// 回调自身,index + 1 进入下个数字的回溯,且传进去的是临时拼接串
backtrack(combinations, phoneMap, digits, index + 1, combination);
// 删除临时拼接串的最后一个拼接的字母,继续 for 循环
combination.deleteCharAt(index);
}
}
}
}
题解分析
回溯过程中维护一个字符串,表示已有的字母排列(如果未遍历完电话号码的所有数字,则已有的字母排列是不完整的)。该字符串初始为空。每次取电话号码的一位数字,从哈希表中获得该数字对应的所有可能的字母,并将其中的一个字母插入到已有的字母排列后面,然后继续处理电话号码的后一位数字,直到处理完电话号码中的所有数字,即得到一个完整的字母排列。然后进行回退操作,遍历其余的字母排列。
回溯算法用于寻找所有的可行解,如果发现一个解不可行,则会舍弃不可行的解。在这道题中,由于每个数字对应的每个字母都可能进入字母组合,因此不存在不可行的解,直接穷举所有的解即可。
leetcode原题:17. 电话号码的字母组合
评论区